;*************************************************************
;  (DMX)      
;  4  (  . )
;      SLOWLY !!!
;************************************************************
;   Filename:           zers4cup.asm
;   First Date:         7 november 2002
;   Last  Date:                    2002
;   File Version:       1.00
;   Assembler:          mpasm 1.40
;   Author:             Bogdanov Andrew
;   E-Mail:             BrSoft@tsrv.ru
;   Info:               Book N4 page
;************************************************************
;  LIST   p=16C73  ; cp=off=1. 3pwrt|on=1. 2wdt|on=1. =HS   *
 __CONFIG b'11111111111110'        ;        *
;************************************************************
#include pic73mac.inc ;                                     *
;************************************************************
;           Bit Definitions                                 *
;************************************************************
#define  flag_0   Flagsdmx,0  ;                       *
#define  flag_1   Flagsdmx,1  ;                *
#define  flag_2   Flagsdmx,2  ;                  *
#define  flag_3   Flagsdmx,3  ;  DMX                 *
;************************************************************
#define  Fstop1   Flags1,0 ; =1= :,=0 =1
#define  Fweit    Flags1,1 ;   
#define  Fstop    Flags1,2 ;   - 
;******************** Ports Bits ****************************
#define  Musik     PortA,0     ; port A -         *
#define  Optron    PortC,5     ; port C -  optrona      *
;************************************************************
;           Register Definitions  20h - 7fh
;******  Roller *************************************
Rollstep1  equ   0x20  ; Roller 1   
Rollcount1 equ   0x21  ; Roller 1  
Rollswith1 equ   0x22  ; Roller 1  
RollSqw1   equ   0x23  ; Roller 1   
Rollstep2  equ   0x24  ; Roller 2   
Rollcount2 equ   0x25  ; Roller 2  
Rollswith2 equ   0x26  ; Roller 2  
RollSqw2   equ   0x27  ; Roller 2   
Rollstep3  equ   0x28  ; Roller 3   
Rollcount3 equ   0x29  ; Roller 3  
Rollswith3 equ   0x2A  ; Roller 3  
RollSqw3   equ   0x2B  ; Roller 3   
Rollstep4  equ   0x2C  ; Roller 4   
Rollcount4 equ   0x2D  ; Roller 4  
Rollswith4 equ   0x2E  ; Roller 4  
RollSqw4   equ   0x2F  ; Roller 4   
;************************************************************
AdrRoll    equ   0x30  ;    Rollers
Rtr_1      equ   0x31  ;   Roller 1
Rtr_2      equ   0x32  ;   Roller 2
Rtr_3      equ   0x33  ;   Roller 3
Rtr_4      equ   0x34  ;   Roller 4
;************************************************************
Flags1    equ   0x40   ; ,   
count_p1  equ   0x41   ; (+RTCC)    LB
count_p2  equ   0x42   ;     HB
count_p3  equ   0x43   ;    
count_m1  equ   0x44   ; (+RTCC)music      LB
count_m2  equ   0x45   ; music      HB
count_r1  equ   0x46   ; (+RTCC)    "a"
count_r2  equ   0x47   ;     "a"
;*************************************************************
dmx_0       equ  0x50   ; 0-  DMX
dmx_1       equ  0x51   ; 1-  DMX
dmx_2       equ  0x52   ; 2-  DMX
dmx_3       equ  0x53   ; 3-  DMX
dmx_4       equ  0x54   ; 4-  DMX
dmx_5       equ  0x55   ; 5-  DMX
dmx_6       equ  0x56   ; 6-  DMX
dmx_7       equ  0x57   ; 7-  DMX
dmx_8       equ  0x58   ; 8-  DMX
dmx_9       equ  0x59   ; 9-  DMX
dmx_10      equ  0x5A   ; 10-  DMX
dmx_11      equ  0x5B   ; 11-  DMX
dmx_12      equ  0x5C   ; 12-  DMX
;-------------------------------------------------------------
lev_0       equ  0x60   ; 0-       
lev_1       equ  0x61   ; 1 = Roller 1     
lev_2       equ  0x62   ; 2 = Roller 2     
lev_3       equ  0x63   ; 3 = Roller 3     
lev_4       equ  0x64   ; 4 = Roller 4      
lev_5       equ  0x65   ; 5 = Maska     
lev_6       equ  0x66   ; 6 = 
lev_7       equ  0x67   ; 7-
lev_8       equ  0x68   ; 8-
lev_9       equ  0x69   ; 9-
lev_10      equ  0x6A   ; 10-
lev_11      equ  0x6B   ; 11-
lev_12      equ  0x6C   ; 12-
;*************    DMX *************************
Flagsdmx  equ   0x70     ; \   
temp_cnt  equ   0x71     ; \ Int    
temp_rx   equ   0x72     ; \ Int     
temp_s    equ   0x73     ; \ Int  
temp_w    equ   0x74     ; \ Int          
rx        equ   0x75     ;   DMX
mode_int  equ   0x76     ;    
first     equ   0x77     ;    
tekuch    equ   0x78     ;    
channel   equ   0x79     ;    
;*************************************************************
konst_r    equ   d'150'  ;     
; 75 = 120   
konst_m    equ   d'070'  ;     
konst_p    equ   d'250'  ;     1sec
konst_l    equ   d'060'  ;    (60-1?)
;*************************************************************
        ORG     0        ;  
        goto    Start    ;    
        nop              ;
        nop              ;
        nop              ;  = 0004h
        goto    int_dmx  ;    -  
;*************************************************************
TabSpeed: addwf PC,f;002-1  2, 250-1  4
 dt  .002,.003,.004,.005,.006,.007,.008,.010
 dt  .014,.020,.027,.035,.050,.100,.200,.250
;***********************************************************************
TabRoller:  addwf   PC,F ; 16   
; Data    , 80=
; 0-7F  (0-),80-FF  (FF-)
;-----------------------------------------------------------------------
;    :   0  31
    dt  0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF ; 00 \ FF
    dt  0xAF,0xAF,0xAF,0xAF,0x50,0x50,0x50,0x50 ; 10 \ EF
    dt  0x30,0x30,0xCF,0xCF,0x30,0x30,0xCF,0xCF ; 20 \ DF
    dt  0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70 ; 30 \ CF
;    :   32  63
    dt  0x00,0x80,0xFF,0x80,0x00,0x80,0xFF,0x80 ; 40 \ BF
    dt  0x00,0x80,0xFF,0x80,0x00,0x80,0xFF,0x80 ; 50 \ AF
    dt  0x10,0x10,0xEF,0xEF,0x10,0x10,0xEF,0xEF ; 60 \ 9F
    dt  0x20,0xDF,0x20,0xDF,0x20,0xDF,0x20,0xDF ; 70 \ 8F
;    :   64  95
    dt  0x10,0x20,0x30,0x40,0x50,0x60,0x70,0x80 ;
    dt  0x8F,0x9F,0xAF,0xBF,0xCF,0xDF,0xEF,0xFF ;
    dt  0x40,0xFF,0x40,0xFF,0x40,0xFF,0x40,0xFF ;
    dt  0x00,0xAF,0x00,0xAF,0x00,0xAF,0x00,0xAF ;
;    :   96  127
    dt  0x10,0xEF,0x80,0x10,0xEF,0x80,0x10,0xEF ;
    dt  0x80,0x10,0xEF,0x80,0x10,0xEF,0x80,0xFF ;
    dt  0x70,0x9F,0x50,0xBF,0x30,0xDF,0x10,0xFF ;
    dt  0x8F,0x8F,0x8F,0x8F,0x8F,0x8F,0x8F,0x80 ;
LongRoll   equ   d'125'  ; 125   
;***********************************************************************
Start:                              ; Main Programm
            bsf         Status,RP0  ; c 1
            movlw       b'00111101' ; A0-in;A1-out
            movwf       TrisA       ;
            movlw       b'11111111' ; B0-B7 - inputs
            movwf       TrisB       ;
            movlw       b'10110000' ; C0-C3-out;C4,C5-in
            movwf       TrisC       ; C7=RX,C6=TX
            movlw       b'00000011' ; HS->Prescaler->Timer0,
            movwf       OptionR     ; 1:16
            movlw       b'00000111' ;  
            movwf       ADCON1      ;
            movlw       b'00100000' ;  
            movwf       PIE1        ; USART
            movlw       d'000'      ; =0, brg=0
            movwf       SPBRG       ; USART
            movlw       b'00100010' ;  BRGH =1 high
            movwf       TXSTA       ; USART      bit2 =0 low
            bcf         Status,RP0  ; c 0
;*************************************************************
            movlw       b'10010000' ;  
            movwf       RCSTA       ; USART
            movlw       b'00000000' ; (bit 5 = 0   data
            movwf       PIR1        ; USART -  !!!
            movlw       b'11000000' ;  
            movwf       INTCON      ; 
;------------------------------------------------------------
          clrf  PortA      ;  
          clrf  PortC      ;
        movlw   0x20       ; 
        movwf   Fsr        ; 
clear_mem:                 ;
        clrf    Indf       ; 
        incf    Fsr,f      ;
        cpi     Fsr,0x7e   ;
        jnz     clear_mem  ;
            clrwdt         ;  WDT 
;*************************************************************
;******************* Code Main Program ***********************
;*************************************************************
base_cuc:                 ;
        clrwdt            ;  WDT 
     movf  PortB,w        ;   
     andlw b'01111111'    ;      W
     movwf first          ;   DMX
     cpi   first,0        ; ??? <<<<<<<<<<<<<<<<
     jz    Prog_Music     ;   
;------   DMX  ---------------------------
     mov     lev_1,dmx_1  ;   MOTOPA 1
     mov     lev_2,dmx_2  ;   MOTOPA 2
     mov     lev_3,dmx_3  ;   MOTOPA 3
     mov     lev_4,dmx_4  ;   MOTOPA 4
;------      -----------------
Order:
        call    PlusTimer    ;   
        call    Roller1      ;    - 
        call    Roller2      ;    - 
        call    Roller3      ;    - 
        call    Roller4      ;    - 
        goto    base_cuc     ;
;--------------------------------------------------------------
Prog_Music:
        btfss   PortB,7      ;   
        goto   mode_program  ; ,   Programma
        goto   mode_music    ; ,  .
;***********************************************************************
mode_music:                  ;     
        call    posle        ; 2 sec   
        btfss   Fstop        ;
        goto  StopMotors     ;  
        mov     lev_1,Rtr_1  ;  Data
        btfsc   Fweit        ;    
        goto    mus_gate     ;  =1,  
        movlw   0ffh         ;  ,
        subwf   count_m1,w   ;    
        jnc     Order        ; ,      
        clrf    count_m1     ; ,
        incf    count_m2,f
        movlw   konst_m      ;    
        subwf   count_m2,w   ;
        jnz     Order        ; ,      
        clrf    count_m2     ;   
        bsf     Fweit        ; . (=1)  
        goto    Order        ;  
StopMotors:
     mvi     Rtr_1,0x80   ;  Rollers
     mov     lev_1,Rtr_1  ;  Data
     goto    Order        ;  
;-----------------------------------------------------------------------
mus_gate:
        btfss   Musik     ;   ?
        goto    Order     ;  
        bcf     Fweit     ; . -   
        goto    Komands   ;    
;---------------   ----------------------------------------
mode_program:
        mov     lev_1,Rtr_1    ;  Data
        movlw   0Efh           ;  
        subwf   count_r1,w     ;  
        jnc     Order          ;     
        clrf    count_r1       ;  
        incf    count_r2,f     ;
        movlw   konst_r        ;  
        subwf   count_r2,w     ;  
        jnz     Order          ;     
        clrf    count_r2       ;  
;---------------------------------------------------------------------
Komands:
     call    ProgRoller   ;    Roller
     mov     lev_1,Rtr_1  ;  Data
     goto    Order        ;  
;***********************************************************************
posle:                     ;    2  
        btfss   Musik      ;   
        goto    posl_nogate;    ?
        bsf     Fstop      ; ,   
        clrf    count_p1   ;   
        clrf    count_p2   ;   
        clrf    count_p3   ;  
        ret
posl_nogate:                   ;   =Musik=
        movlw   0Efh           ;    
        subwf   count_p1,w     ;
        jnc     posl_ret       ; ret,      
        clrf    count_p1       ;   
        incf    count_p2,f     ;
        movlw   konst_p        ;    
        subwf   count_p2,w     ;
        jnz     posl_ret       ; ret,      
        clrf    count_p2       ;   
        bcf     Fstop  ; ,   
        goto    posl_ret
    incf    count_p3,f      ;
    movlw   konst_l         ;    
    subwf   count_p3,w      ;
    jnz     posl_ret        ; ret,      
;   bcf     Flamp   ;  
posl_ret:
        ret
;***********************************************************************
ProgRoller: ;      Rollers
        movf    AdrRoll,W       ;   -> W
        call    TabRoller       ;  -> W
        movtof  Rtr_1           ; Roller
        incf    AdrRoll,f       ;  
        cpi     AdrRoll,LongRoll;   
        rnz                     ;   arg < const
        clrf    AdrRoll
        return
;************************************************************
;============================================================
Roller1:                     ;   1
;============================================================
;************************************************************
        cpi     lev_1,.121   ;
        btfsc   Status,0     ;
        goto    Roll1direct  ;
        cpi     lev_1,.134   ;
        btfsc   Status,0     ;
        return               ;
Roll1direct:                 ;
        btfss   lev_1,7      ;   0-,1-
        goto    Roll1_left   ;  0    
;*************************************************************
Roll1_right: ;     1
;*************************************************************
        comf    lev_1,f     ;   co
        rrf     lev_1,f
        rrf     lev_1,f
        rrf     lev_1,f
        movlw   b'00001111'
        andwf   lev_1,w
        call    TabSpeed    ;   
        subwf   Rollcount1,w;   
        btfss   Status,CR   ;   
        goto    cross_r1    ; ,  
        clrf    Rollcount1  ;   
        incf    Rollstep1,f ;   
        jnz     cross_r1    ;   = 0  
        decf    Rollswith1,f;     
        movlw   b'00000011' ; (   )
        andwf   Rollswith1,f;   
cross_r1:                   ;
        decf    RollSqw1,f  ;  
        movlw   1           ;    
        subwf   Rollswith1,w;     
        jz      Roll1varR2  ; 2
        movlw   2           ;    
        subwf   Rollswith1,w;     
        jz      Roll1varR3  ; 3
        movlw   3           ;    
        subwf   Rollswith1,w;     
        jz      Roll1varR4  ; 4
;-------------------------------------------------------------
Roll1varR1: ;     
        cmp     RollSqw1,Rollstep1 ;   
        btfsc   Status,0        ;
        goto    ust100010       ;   - 1->0
        goto    ust100100       ;   - 0->1
;-------------------------------------------------------------
Roll1varR2: ;     
        cmp     RollSqw1,Rollstep1 ;   
        btfsc   Status,0
        goto    ust010010       ;   - 1->0
        goto    ust100010       ;   - 0->1
;-------------------------------------------------------------
Roll1varR3: ;     
        cmp     RollSqw1,Rollstep1 ;   
        btfsc   Status,0
        goto    ust010100       ;   - 1->0
        goto    ust010010       ;   - 0->1
;-------------------------------------------------------------
Roll1varR4: ;     
        cmp     RollSqw1,Rollstep1 ;   
        btfsc   Status,0
        goto    ust100100       ;   - 1->0
        goto    ust010100       ;   - 0->1
;*************************************************************
Roll1_left:  ;      1
;*************************************************************
        movf    lev_1,f     ;   co
        rrf     lev_1,f
        rrf     lev_1,f
        rrf     lev_1,f
        movlw   b'00001111'
        andwf   lev_1,w
       call    TabSpeed    ;   
        subwf   Rollcount1,w;   
        btfss   Status,CR   ;   
        goto    cross_l1    ; ,  
        clrf    Rollcount1  ;   
        incf    Rollstep1,f ;   
        jnz     cross_l1    ;   = 0  
        incf    Rollswith1,f; ???    
        movlw   b'00000011' ; (   )
        andwf   Rollswith1,f;   
cross_l1:                   ;
        incf    RollSqw1,f  ;  
        movlw   1           ;    
        subwf   Rollswith1,w;     
        jz      Roll1varL2        ; 2
        movlw   2           ;    
        subwf   Rollswith1,w;     
        jz      Roll1varL3        ; 3
        movlw   3           ;    
        subwf   Rollswith1,w;     
        jz      Roll1varL4        ; 4
        goto    Roll1varL1
;-------------------------------------------------------------
Roll1varL1: ;     
        cmp     RollSqw1,Rollstep1 ;   
        btfss   Status,0        ;
        goto    ust100010       ;   - 1->0
        goto    ust100100       ;   - 0->1
;-------------------------------------------------------------
Roll1varL2: ;     
        cmp     RollSqw1,Rollstep1 ;   
        btfss   Status,0
        goto    ust010010       ;   - 1->0
        goto    ust100010       ;   - 0->1
;-------------------------------------------------------------
Roll1varL3: ;     
        cmp     RollSqw1,Rollstep1 ;   
        btfss   Status,0
        goto    ust010100       ;   - 1->0
        goto    ust010010       ;   - 0->1
;-------------------------------------------------------------
Roll1varL4: ;     
        cmp     RollSqw1,Rollstep1 ;   
        btfss   Status,0
        goto    ust100100       ;   - 1->0
        goto    ust010100       ;   - 0->1
;-------------------------------------------------------------
ust100010:              ; 1
     movf  PortC,w      ;   C -> W
     andlw 0f0h         ;      W
     iorlw b'00001001'  ;     
      movwf PortC        ;      C
     return             ;
ust100100:              ; 2
     movf  PortC,w      ;   C -> W
     andlw 0f0h         ;      W
     iorlw b'00001010'  ;     
      movwf PortC        ;      C
     return             ;
ust010010:              ; 3
     movf  PortC,w      ;   C -> W
     andlw 0f0h         ;      W
     iorlw b'00000101'  ;     
      movwf PortC        ;      C
     return             ;
ust010100:              ; 4
     movf  PortC,w      ;   C -> W
     andlw 0f0h         ;      W
     iorlw b'00000110'  ;     
      movwf PortC        ;      C
     return             ;
;************************************************************
;222222222222222222222222222222222222222222222222222222222222
Roller2:                     ;   2
;============================================================
;************************************************************
        cpi     lev_2,.121   ;
        btfsc   Status,0     ;
        goto    Roll2direct  ;
        cpi     lev_2,.134   ;
        btfsc   Status,0     ;
        return               ;
Roll2direct:                 ;
        btfss   lev_2,7      ;   0-,1-
        goto    Roll2_left   ;  0    
;*************************************************************
Roll2_right: ;     1
;*************************************************************
        comf    lev_2,f     ;   co
        rrf     lev_2,f
        rrf     lev_2,f
        rrf     lev_2,f
        movlw   b'00001111'
        andwf   lev_2,w
        call    TabSpeed    ;   
        subwf   Rollcount2,w;   
        btfss   Status,CR   ;   
        goto    cross_r2    ; ,  
        clrf    Rollcount2  ;   
        incf    Rollstep2,f ;   
        jnz     cross_r2    ;   = 0  
        decf    Rollswith2,f;     
        movlw   b'00000011' ; (   )
        andwf   Rollswith2,f;   
cross_r2:                   ;
        decf    RollSqw2,f  ;  
        movlw   1           ;    
        subwf   Rollswith2,w;     
        jz      Roll2varR2  ; 2
        movlw   2           ;    
        subwf   Rollswith2,w;     
        jz      Roll2varR3  ; 3
        movlw   3           ;    
        subwf   Rollswith2,w;     
        jz      Roll2varR4  ; 4
;-------------------------------------------------------------
Roll2varR1: ;     
        cmp     RollSqw2,Rollstep2 ;   
        btfsc   Status,0        ;
        goto    us2100010       ;   - 1->0
        goto    us2100100       ;   - 0->1
;-------------------------------------------------------------
Roll2varR2: ;     
        cmp     RollSqw2,Rollstep2 ;   
        btfsc   Status,0
        goto    us2010010       ;   - 1->0
        goto    us2100010       ;   - 0->1
;-------------------------------------------------------------
Roll2varR3: ;     
        cmp     RollSqw1,Rollstep1 ;   
        btfsc   Status,0
        goto    us2010100       ;   - 1->0
        goto    us2010010       ;   - 0->1
;-------------------------------------------------------------
Roll2varR4: ;     
        cmp     RollSqw2,Rollstep2 ;   
        btfsc   Status,0
        goto    us2100100       ;   - 1->0
        goto    us2010100       ;   - 0->1
;*************************************************************
Roll2_left:  ;      1
;*************************************************************
        movf    lev_2,f     ;   co
        rrf     lev_2,f
        rrf     lev_2,f
        rrf     lev_2,f
        movlw   b'00001111'
        andwf   lev_2,w
       call    TabSpeed    ;   
        subwf   Rollcount2,w;   
        btfss   Status,CR   ;   
        goto    cross_l2    ; ,  
        clrf    Rollcount2  ;   
        incf    Rollstep2,f ;   
        jnz     cross_l2    ;   = 0  
        incf    Rollswith2,f; ???    
        movlw   b'00000011' ; (   )
        andwf   Rollswith2,f;   
cross_l2:                   ;
        incf    RollSqw2,f  ;  
        movlw   1           ;    
        subwf   Rollswith2,w;     
        jz      Roll2varL2        ; 2
        movlw   2           ;    
        subwf   Rollswith2,w;     
        jz      Roll2varL3        ; 3
        movlw   3           ;    
        subwf   Rollswith2,w;     
        jz      Roll2varL4        ; 4
        goto    Roll2varL1
;-------------------------------------------------------------
Roll2varL1: ;     
        cmp     RollSqw2,Rollstep2 ;   
        btfss   Status,0        ;
        goto    us2100010       ;   - 1->0
        goto    us2100100       ;   - 0->1
;-------------------------------------------------------------
Roll2varL2: ;     
        cmp     RollSqw2,Rollstep2 ;   
        btfss   Status,0
        goto    us2010010       ;   - 1->0
        goto    us2100010       ;   - 0->1
;-------------------------------------------------------------
Roll2varL3: ;     
        cmp     RollSqw2,Rollstep2 ;   
        btfss   Status,0
        goto    us2010100       ;   - 1->0
        goto    us2010010       ;   - 0->1
;-------------------------------------------------------------
Roll2varL4: ;     
        cmp     RollSqw2,Rollstep2 ;   
        btfss   Status,0
        goto    us2100100       ;   - 1->0
        goto    us2010100       ;   - 0->1
;-------------------------------------------------------------
us2100010:              ; 1
     movf  PortC,w      ;   C -> W
     andlw 0f0h         ;      W
     iorlw b'00001001'  ;     
;    movwf PortC        ;      C
     return             ;
us2100100:              ; 2
     movf  PortC,w      ;   C -> W
     andlw 0f0h         ;      W
     iorlw b'00001010'  ;     
;    movwf PortC        ;      C
     return             ;
us2010010:              ; 3
     movf  PortC,w      ;   C -> W
     andlw 0f0h         ;      W
     iorlw b'00000101'  ;     
;    movwf PortC        ;      C
     return             ;
us2010100:              ; 4
     movf  PortC,w      ;   C -> W
     andlw 0f0h         ;      W
     iorlw b'00000110'  ;     
;    movwf PortC        ;      C
     return             ;
;************************************************************
;333333333333333333333333333333333333333333333333333333333333
Roller3:                     ;   3
;============================================================
;************************************************************
        cpi     lev_3,.121   ;
        btfsc   Status,0     ;
        goto    Roll3direct  ;
        cpi     lev_3,.134   ;
        btfsc   Status,0     ;
        return               ;
Roll3direct:                 ;
        btfss   lev_3,7      ;   0-,1-
        goto    Roll3_left   ;  0    
;*************************************************************
Roll3_right: ;     1
;*************************************************************
        comf    lev_3,f     ;   co
        rrf     lev_3,f
        rrf     lev_3,f
        rrf     lev_3,f
        movlw   b'00001111'
        andwf   lev_3,w
        call    TabSpeed    ;   
        subwf   Rollcount3,w;   
        btfss   Status,CR   ;   
        goto    cross_r3    ; ,  
        clrf    Rollcount3  ;   
        incf    Rollstep3,f ;   
        jnz     cross_r3    ;   = 0  
        decf    Rollswith3,f;     
        movlw   b'00000011' ; (   )
        andwf   Rollswith3,f;   
cross_r3:                   ;
        decf    RollSqw3,f  ;  
        movlw   1           ;    
        subwf   Rollswith3,w;     
        jz      Roll3varR2  ; 2
        movlw   2           ;    
        subwf   Rollswith3,w;     
        jz      Roll3varR3  ; 3
        movlw   3           ;    
        subwf   Rollswith3,w;     
        jz      Roll3varR4  ; 4
;-------------------------------------------------------------
Roll3varR1: ;     
        cmp     RollSqw3,Rollstep3 ;   
        btfsc   Status,0        ;
        goto    us3100010       ;   - 1->0
        goto    us3100100       ;   - 0->1
;-------------------------------------------------------------
Roll3varR2: ;     
        cmp     RollSqw3,Rollstep3 ;   
        btfsc   Status,0
        goto    us3010010       ;   - 1->0
        goto    us3100010       ;   - 0->1
;-------------------------------------------------------------
Roll3varR3: ;     
        cmp     RollSqw3,Rollstep3 ;   
        btfsc   Status,0
        goto    us3010100       ;   - 1->0
        goto    us3010010       ;   - 0->1
;-------------------------------------------------------------
Roll3varR4: ;     
        cmp     RollSqw3,Rollstep3 ;   
        btfsc   Status,0
        goto    us3100100       ;   - 1->0
        goto    us3010100       ;   - 0->1
;*************************************************************
Roll3_left:  ;      3
;*************************************************************
        movf    lev_3,f     ;   co
        rrf     lev_3,f
        rrf     lev_3,f
        rrf     lev_3,f
        movlw   b'00001111'
        andwf   lev_3,w
       call    TabSpeed    ;   
        subwf   Rollcount3,w;   
        btfss   Status,CR   ;   
        goto    cross_l3    ; ,  
        clrf    Rollcount3  ;   
        incf    Rollstep3,f ;   
        jnz     cross_l3    ;   = 0  
        incf    Rollswith3,f; ???    
        movlw   b'00000011' ; (   )
        andwf   Rollswith3,f;   
cross_l3:                   ;
        incf    RollSqw3,f  ;  
        movlw   1           ;    
        subwf   Rollswith1,w;     
        jz      Roll3varL2        ; 2
        movlw   2           ;    
        subwf   Rollswith1,w;     
        jz      Roll3varL3        ; 3
        movlw   3           ;    
        subwf   Rollswith1,w;     
        jz      Roll3varL4        ; 4
        goto    Roll3varL1
;-------------------------------------------------------------
Roll3varL1: ;     
        cmp     RollSqw3,Rollstep3 ;   
        btfss   Status,0        ;
        goto    us3100010       ;   - 1->0
        goto    us3100100       ;   - 0->1
;-------------------------------------------------------------
Roll3varL2: ;     
        cmp     RollSqw3,Rollstep3 ;   
        btfss   Status,0
        goto    us3010010       ;   - 1->0
        goto    us3100010       ;   - 0->1
;-------------------------------------------------------------
Roll3varL3: ;     
        cmp     RollSqw3,Rollstep3 ;   
        btfss   Status,0
        goto    us3010100       ;   - 1->0
        goto    us3010010       ;   - 0->1
;-------------------------------------------------------------
Roll3varL4: ;     
        cmp     RollSqw3,Rollstep3 ;   
        btfss   Status,0
        goto    us3100100       ;   - 1->0
        goto    us3010100       ;   - 0->1
;-------------------------------------------------------------
us3100010:              ; 1
     movf  PortC,w      ;   C -> W
     andlw 0f0h         ;      W
     iorlw b'00001001'  ;     
;    movwf PortC        ;      C
     return             ;
us3100100:              ; 2
     movf  PortC,w      ;   C -> W
     andlw 0f0h         ;      W
     iorlw b'00001010'  ;     
;    movwf PortC        ;      C
     return             ;
us3010010:              ; 3
     movf  PortC,w      ;   C -> W
     andlw 0f0h         ;      W
     iorlw b'00000101'  ;     
;    movwf PortC        ;      C
     return             ;
us3010100:              ; 4
     movf  PortC,w      ;   C -> W
     andlw 0f0h         ;      W
     iorlw b'00000110'  ;     
;    movwf PortC        ;      C
     return             ;
;************************************************************
;444444444444444444444444444444444444444444444444444444444444
Roller4:                     ;   4
;============================================================
;************************************************************
        cpi     lev_4,.121   ;
        btfsc   Status,0     ;
        goto    Roll4direct  ;
        cpi     lev_4,.134   ;
        btfsc   Status,0     ;
        return               ;
Roll4direct:                 ;
        btfss   lev_4,7      ;   0-,1-
        goto    Roll4_left   ;  0    
;*************************************************************
Roll4_right: ;     4
;*************************************************************
        comf    lev_4,f     ;   co
        rrf     lev_4,f
        rrf     lev_4,f
        rrf     lev_4,f
        movlw   b'00001111'
        andwf   lev_4,w
        call    TabSpeed    ;   
        subwf   Rollcount4,w;   
        btfss   Status,CR   ;   
        goto    cross_r4    ; ,  
        clrf    Rollcount4  ;   
        incf    Rollstep4,f ;   
        jnz     cross_r4    ;   = 0  
        decf    Rollswith4,f;     
        movlw   b'00000011' ; (   )
        andwf   Rollswith4,f;   
cross_r4:                   ;
        decf    RollSqw4,f  ;  
        movlw   1           ;    
        subwf   Rollswith4,w;     
        jz      Roll4varR2  ; 2
        movlw   2           ;    
        subwf   Rollswith4,w;     
        jz      Roll4varR3  ; 3
        movlw   3           ;    
        subwf   Rollswith4,w;     
        jz      Roll4varR4  ; 4
;-------------------------------------------------------------
Roll4varR1: ;     
        cmp     RollSqw4,Rollstep4 ;   
        btfsc   Status,0        ;
        goto    us4100010       ;   - 1->0
        goto    us4100100       ;   - 0->1
;-------------------------------------------------------------
Roll4varR2: ;     
        cmp     RollSqw4,Rollstep4 ;   
        btfsc   Status,0
        goto    us4010010       ;   - 1->0
        goto    us4100010       ;   - 0->1
;-------------------------------------------------------------
Roll4varR3: ;     
        cmp     RollSqw4,Rollstep4 ;   
        btfsc   Status,0
        goto    us4010100       ;   - 1->0
        goto    us4010010       ;   - 0->1
;-------------------------------------------------------------
Roll4varR4: ;     
        cmp     RollSqw4,Rollstep4 ;   
        btfsc   Status,0
        goto    us4100100       ;   - 1->0
        goto    us4010100       ;   - 0->1
;*************************************************************
Roll4_left:  ;      4
;*************************************************************
        movf    lev_4,f     ;   co
        rrf     lev_4,f
        rrf     lev_4,f
        rrf     lev_4,f
        movlw   b'00001111'
        andwf   lev_4,w
       call    TabSpeed    ;   
        subwf   Rollcount4,w;   
        btfss   Status,CR   ;   
        goto    cross_l4    ; ,  
        clrf    Rollcount4  ;   
        incf    Rollstep4,f ;   
        jnz     cross_l4    ;   = 0  
        incf    Rollswith4,f; ???    
        movlw   b'00000011' ; (   )
        andwf   Rollswith4,f;   
cross_l4:                   ;
        incf    RollSqw4,f  ;  
        movlw   1           ;    
        subwf   Rollswith4,w;     
        jz      Roll4varL2        ; 2
        movlw   2           ;    
        subwf   Rollswith4,w;     
        jz      Roll4varL3        ; 3
        movlw   3           ;    
        subwf   Rollswith4,w;     
        jz      Roll4varL4        ; 4
        goto    Roll4varL1
;-------------------------------------------------------------
Roll4varL1: ;     
        cmp     RollSqw4,Rollstep4 ;   
        btfss   Status,0        ;
        goto    us4100010       ;   - 1->0
        goto    us4100100       ;   - 0->1
;-------------------------------------------------------------
Roll4varL2: ;     
        cmp     RollSqw4,Rollstep4 ;   
        btfss   Status,0
        goto    us4010010       ;   - 1->0
        goto    us4100010       ;   - 0->1
;-------------------------------------------------------------
Roll4varL3: ;     
        cmp     RollSqw4,Rollstep4 ;   
        btfss   Status,0
        goto    us4010100       ;   - 1->0
        goto    us4010010       ;   - 0->1
;-------------------------------------------------------------
Roll4varL4: ;     
        cmp     RollSqw4,Rollstep4 ;   
        btfss   Status,0
        goto    us4100100       ;   - 1->0
        goto    us4010100       ;   - 0->1
;-------------------------------------------------------------
us4100010:              ; 1
     movf  PortC,w      ;   C -> W
     andlw 0f0h         ;      W
     iorlw b'00001001'  ;     
;    movwf PortC        ;      C
     return             ;
us4100100:              ; 2
     movf  PortC,w      ;   C -> W
     andlw 0f0h         ;      W
     iorlw b'00001010'  ;     
;    movwf PortC        ;      C
     return             ;
us4010010:              ; 3
     movf  PortC,w      ;   C -> W
     andlw 0f0h         ;      W
     iorlw b'00000101'  ;     
;    movwf PortC        ;      C
     return             ;
us4010100:              ; 4
     movf  PortC,w      ;   C -> W
     andlw 0f0h         ;      W
     iorlw b'00000110'  ;     
;    movwf PortC        ;      C
     return             ;
;**************************************************************
;      -  
;**************************************************************
int_dmx:                       ;
        movwf   temp_w         ;  W
        swapf   Status,w       ;  Status
        bcf     Status,RP0     ;  0
        movwf   temp_s         ; c  PUSH
;-------   -------------------------------------
        btfsc   RCSTA,2        ;  -  STOP-BIT
        goto    int_gate       ;   
        btfsc   flag_0         ;    
        goto    int_wait00     ;     =00=
        btfsc   flag_1         ;
        goto    int_reciv      ;   
        btfsc   flag_2         ;
        goto    int_write      ;   
        clrf    Flagsdmx       ;  
        mov     rx,RCREG       ;   
        goto    ret_int        ;   
;---------------------------------------------------------------
int_wait00:                    ;   =00=
        mov     rx,RCREG       ;   
        mvi     tekuch,1       ;  
        cpi     rx,0x00        ;   =00=  
        jnz     ret_int        ;    
        bcf     flag_0         ;   
        bsf     flag_1         ; .  
        goto    ret_int        ;  =00=   
;---------------------------------------------------------------
int_reciv:                     ;    
;       bcf     flag_0         ;   
;       bsf     flag_1         ; .  
        mvi     channel,1      ;  
        cmp     tekuch,first   ;    
        jz      int_write      ;    
        mov     rx,RCREG       ;   
        incf    tekuch,f       ;   DMX
        goto    ret_int        ;   
;---------------------------------------------------------------
int_write:
        bcf     flag_1         ; c  
        bsf     flag_2         ; .  
        mvi     FSR,dmx_0      ; 
        movf    channel,w      ;   
        addwf   FSR,f          ;  
        mov     INDF,RCREG     ;   
        incf    channel,f      ;  
        cpi     channel,.13    ;  
        jnz     ret_int        ;    
        clrf    Flagsdmx       ; c  - 
        goto    ret_int        ;   
;---------------------------------------------------------------
int_gate:        ;    DMX
        bsf     flag_0         ; .  
        mov     rx,RCREG       ;   
ret_int:
        swapf   temp_s,w       ; c  POP
        movwf   Status         ;  Status
        swapf   temp_w,f       ;  W 
        swapf   temp_w,w       ;   Z !
        retfie      ;       
;**************************************************************
PlusTimer:                 ;   
        btfss    Timer,2   ;    2
        return             ;   2=0 ->  
        clrf     Timer     ;   2=1 ->    |  
        incf    count_p1,f ;   | 
        incf    count_m1,f ;! .    |  
        incf    count_r1,f ;!    |   
        incf    Rollcount1,f;   =1=
        incf    Rollcount2,f;   =2=
        incf    Rollcount3,f;   =3=
        incf    Rollcount4,f;   =4=
        clrwdt              ;  WDT 
        return
;**************************************************************
;     " BrSoft Copyright (C) 2001 Bogdanov Andrew "
;**************************************************************

           End


